#Making a PICO-8 TAS - Part 2: Communication

## Problem

The first order of business for setting up tooling to control a running session
of Celeste was to create a system for allowing JavaScript and PICO-8 to
communicate over the GPIO pins.

The setup is this:
There's a 128-byte region of memory (`0x5f80` to `0x5fff`) within PICO-8 which
is mapped to a global JavaScript array, `pico8_gpio`.
Both PICO-8 and JavaScript can read and write to this section, and both can
poll reading it at 60fps.

There's two important things to note about the system:

1. Since JavaScript is single-threaded and the PICO-8 web player is still just
   in JavaScript, we don't need to worry about any kind of concurrent access or
   locking
2. Message order is guaranteed, so we don't need to worry about providing an
   order for the different pieces of a message.

These two facts mean our protocol can be relatively simple.
I'll outline the protocol I came up with here, and I should preface this by
saying I have no experience in networking or binary protocols, so it's possible
there's some amateurish missteps :)

So all we have to do now is come up with a protocol for the two to use in this
shared chunk of memory to communicate.
I'll briefly outline the protocol I came up with, I don't argue that it's the
best, and I have no experience in networking, but I think it's at least reasonable, given the restrictions of the problem.
