import React, { Component } from 'react';
import './Controller.css';

class Button extends Component {
  constructor() {
    super();
    this.handleClick = this.handleClick.bind(this);
  }

  render() {
    let down = (Math.pow(2, this.props.which) & this.props.bitmask) > 0;
    return <div
      className={
        `
        controller-button-${this.props.which} 
        ${down ? 'controller-button-down' : ''}
        controller-button
        `}
        onClick={this.handleClick}
        >
    </div>;
  }

  handleClick(e) {
    this.props.onClick(this.props.which);
  }
}

export default class Controller extends Component {
  constructor() {
    super();
    this.handleClick = this.handleClick.bind(this);
  }

  render() {
    let bitmask = this.props.bitmask;
    return <div className='controller-box'>
      <Button bitmask={bitmask} which={0} onClick={this.handleClick} />
      <Button bitmask={bitmask} which={1} onClick={this.handleClick} />
      <Button bitmask={bitmask} which={2} onClick={this.handleClick} />
      <Button bitmask={bitmask} which={3} onClick={this.handleClick} />
      <Button bitmask={bitmask} which={4} onClick={this.handleClick} />
      <Button bitmask={bitmask} which={5} onClick={this.handleClick} />
    </div>;
  }

  handleClick(i) {
    if (this.props.onChange) {
      this.props.onChange(this.props.bitmask ^ Math.pow(2, i));
    }
  }
}
